=== debian/changelog ===
mrcal (2.1-5build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 15:58:12 +0000

mrcal (2.1-5) unstable; urgency=medium

  * Test suite passes on arm64

 -- Dima Kogan <dkogan@debian.org>  Sun, 13 Feb 2022 19:29:22 -0800

mrcal (2.1-4) unstable; urgency=medium

  * Build works with a newer argparse

 -- Dima Kogan <dkogan@debian.org>  Sun, 13 Feb 2022 00:56:25 -0800

mrcal (2.1-3) unstable; urgency=medium

  * added build patch to diagnose an Ubuntu build failure

 -- Dima Kogan <dkogan@debian.org>  Sat, 12 Feb 2022 23:21:36 -0800

mrcal (2.1-2) unstable; urgency=medium

  * mrcal builds for non-amd64 architectures
  * mrcal is cross-buildable
  * mrcal builds packages for all the installed python versions

 -- Dima Kogan <dkogan@debian.org>  Mon, 24 Jan 2022 12:08:08 -0800

mrcal (2.1-1) unstable; urgency=medium

  * Initial release into Debian (Closes: #998795)

 -- Dima Kogan <dkogan@debian.org>  Fri, 19 Nov 2021 16:43:18 -0800
