=== debian/control ===
Source: mrcal
Priority: optional
Section: devel
Build-Depends:
# Please do not "fix" to use debhelper-compat. I want this to remain compatible
# with older debian-based distros
 debhelper (>= 11),
 dh-python,
 libdogleg-dev (>= 0.15.4),
 libsuitesparse-dev (>= 1:4.5.2),
 perl:native, liblist-moreutils-perl:native,
 vnlog,
 chrpath,
 re2c (>= 2),
 python3-all-dev:any,
 libpython3-all-dev,
# These are for the tests only, so :native
 python3-gnuplotlib (>= 0.38) <!nocheck>,
 python3-numpysane (>= 0.35)  <!nocheck>,
 python3-opencv               <!nocheck>,
 python3-numpy                <!nocheck>,
 python3-scipy (>= 0.18)      <!nocheck>
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.6.0
Homepage: http://mrcal.secretsauce.net
Vcs-Git: https://salsa.debian.org/science-team/mrcal.git
Vcs-Browser: https://salsa.debian.org/science-team/mrcal
Testsuite: autopkgtest-pkg-python

Package: libmrcal2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Calibration and SFM library
 A photogrammetry toolkit that provides improved methods for making and using
 camera models (calibration, tracking, mapping, etc). The focus is on
 calibration and uncertainty propagation to produce the most accurate models
 possible. This package provides the runtime C libraries

Package: mrcal
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal2 (= ${binary:Version}),
         python3-mrcal (= ${binary:Version}),
         python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
         python3-scipy (>= 0.18),  python3-ipython,
         python3-opencv, python3,
         mrgingham (>= 1.5)
Description: Calibration and SFM library
 A photogrammetry toolkit that provides improved methods for making and using
 camera models (calibration, tracking, mapping, etc). The focus is on
 calibration and uncertainty propagation to produce the most accurate models
 possible. This package provides the user-facing tools

Package: libmrcal-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmrcal2 (= ${binary:Version})
Description: Calibration and SFM library
 A photogrammetry toolkit that provides improved methods for making and using
 camera models (calibration, tracking, mapping, etc). The focus is on
 calibration and uncertainty propagation to produce the most accurate models
 possible. This package provides the development C libraries

Package: python3-mrcal
Section: python
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal2 (= ${binary:Version}),
         ${python3:Depends},
         python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
         python3-opencv, python3-numpy, python3-scipy (>= 0.18),
         python3-shapely, python3-ipython,
# for image_transformation_map(), not for plotting
         python3-matplotlib
Provides: ${python3:Provides}
Description: Calibration and SFM library
 A photogrammetry toolkit that provides improved methods for making and using
 camera models (calibration, tracking, mapping, etc). The focus is on
 calibration and uncertainty propagation to produce the most accurate models
 possible. This package provides the Python interfaces
