=== debian/changelog ===
mrcal (2.2-4) unstable; urgency=medium

  * Cleaned up Build-Depends to work with the nocheck profile and to
    cross-build successfully (Closes: #1029083)

 -- Dima Kogan <dkogan@debian.org>  Tue, 17 Jan 2023 09:55:00 -0800

mrcal (2.2-3) focal; urgency=medium

  * Disabled mrcal-convert-lensmodel test to fix intermittent test failure

 -- Dima Kogan <dkogan@debian.org>  Tue, 25 Oct 2022 12:11:49 -0700

mrcal (2.2-2) unstable; urgency=medium

  * more tries in test-convert-lensmodel to fix test failure

 -- Dima Kogan <dkogan@debian.org>  Wed, 05 Oct 2022 21:57:00 -0700

mrcal (2.2-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Mon, 03 Oct 2022 21:18:47 -0700
