=== debian/control ===
--- 
+++ 
@@ -8,17 +8,23 @@
  dh-python,
  libdogleg-dev (>= 0.15.4),
  libsuitesparse-dev (>= 1:4.5.2),
- perl:native, liblist-moreutils-perl:native,
+ libfreeimage-dev,
+ perl:any,
+ liblist-moreutils-perl:native,
  vnlog,
  chrpath,
  re2c (>= 2),
  python3-all-dev:any,
  libpython3-all-dev,
-# These are for the tests only, so :native
+# Needed for *-genpywrap.py. Need arch:build for tests, but testing while
+# cross-building doesn't work anyway
+ python3-numpy:native,
+# Need this even when not running tests: *-genpywrap.py uses npsp
+ python3-numpysane (>= 0.35),
+ mrbuild,
+# These are for the tests only
  python3-gnuplotlib (>= 0.38) <!nocheck>,
- python3-numpysane (>= 0.35)  <!nocheck>,
  python3-opencv               <!nocheck>,
- python3-numpy                <!nocheck>,
  python3-scipy (>= 0.18)      <!nocheck>
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>
@@ -47,6 +53,8 @@
          python3-scipy (>= 0.18),  python3-ipython,
          python3-opencv, python3,
          mrgingham (>= 1.5)
+Recommends: python3-fltk,
+            python3-gl-image-display
 Description: Calibration and SFM library
  A photogrammetry toolkit that provides improved methods for making and using
  camera models (calibration, tracking, mapping, etc). The focus is on
