=== debian/watch ===
version=4
https://github.com/dkogan/mrcal/tags .*/v?(\d\S+)\.tar\.gz
