=== debian/changelog ===
mrcal (2.3-4) unstable; urgency=medium

  * Explicitly linking with libsuitesparseconfig. Adds explicit dependency
    that makes it harder to end up with incompatible packages

 -- Dima Kogan <dkogan@debian.org>  Wed, 06 Sep 2023 21:51:00 -0700

mrcal (2.3-3) unstable; urgency=medium

  * Tightened libdogleg-dev version dependency

 -- Dima Kogan <dkogan@debian.org>  Sat, 22 Jul 2023 21:46:39 -0700

mrcal (2.3-2) unstable; urgency=medium

  * Build with latest suitesparse packages

 -- Dima Kogan <dkogan@debian.org>  Tue, 18 Jul 2023 22:50:02 -0700

mrcal (2.3-1) unstable; urgency=medium

  * New upstream release
  * New C library package for the updated ABI: libmrcal3

 -- Dima Kogan <dkogan@debian.org>  Thu, 04 May 2023 22:38:49 -0700
