=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 # with older debian-based distros
  debhelper (>= 11),
  dh-python,
- libdogleg-dev (>= 0.15.4),
+ libdogleg-dev (>= 0.16-4),
  libsuitesparse-dev (>= 1:4.5.2),
  libfreeimage-dev,
  perl:any,
@@ -34,7 +34,7 @@
 Vcs-Browser: https://salsa.debian.org/science-team/mrcal
 Testsuite: autopkgtest-pkg-python
 
-Package: libmrcal2
+Package: libmrcal3
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -47,7 +47,7 @@
 
 Package: mrcal
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal2 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal3 (= ${binary:Version}),
          python3-mrcal (= ${binary:Version}),
          python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
          python3-scipy (>= 0.18),  python3-ipython,
@@ -65,7 +65,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libmrcal2 (= ${binary:Version})
+Depends: ${misc:Depends}, libmrcal3 (= ${binary:Version})
 Description: Calibration and SFM library
  A photogrammetry toolkit that provides improved methods for making and using
  camera models (calibration, tracking, mapping, etc). The focus is on
@@ -76,7 +76,7 @@
 Section: python
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal2 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal3 (= ${binary:Version}),
          ${python3:Depends},
          python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
          python3-opencv, python3-numpy, python3-scipy (>= 0.18),
