## mrcal 2.4.1

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 include choose_mrbuild.mk
 include $(MRBUILD_MK)/Makefile.common.header
+
 
 # "0" or undefined means "false"
 # everything else means  "true"
@@ -15,7 +16,7 @@
 
 
 PROJECT_NAME := mrcal
-ABI_VERSION  := 3
+ABI_VERSION  := 4
 TAIL_VERSION := 0
 
 VERSION := $(VERSION_FROM_PROJECT)
@@ -49,7 +50,7 @@
 endif
 
 CFLAGS    += --std=gnu99
-CCXXFLAGS += -Wno-missing-field-initializers -Wno-unused-variable -Wno-unused-parameter
+CCXXFLAGS += -Wno-missing-field-initializers -Wno-unused-variable -Wno-unused-parameter -Wno-missing-braces
 
 $(patsubst %.c,%.o,$(shell grep -l '#include .*minimath\.h' *.c */*.c)): minimath/minimath_generated.h
 minimath/minimath_generated.h: minimath/minimath_generate.pl
@@ -80,6 +81,9 @@
 	mrcal-graft-models			\
 	mrcal-to-cahvor				\
 	mrcal-from-cahvor			\
+	mrcal-to-kalibr				\
+	mrcal-from-kalibr			\
+	mrcal-from-ros				\
 	mrcal-show-geometry			\
 	mrcal-show-valid-intrinsics-region	\
 	mrcal-is-within-valid-intrinsics-region \
@@ -93,6 +97,9 @@
 # hack because apparenly manpages from python tools is a crazy thing to want to
 # do
 DIST_MAN := $(addsuffix .1,$(DIST_BIN))
+
+# if using an older mrbuild SO won't be defined, and we need it
+SO ?= so
 
 # parser
 cameramodel-parser_GENERATED.c: cameramodel-parser.re mrcal.h
@@ -112,7 +119,7 @@
 ######### python stuff
 %-npsp-pywrap-GENERATED.c: %-genpywrap.py
 	python3 $< > $@.tmp && mv $@.tmp $@
-mrcal/_%_npsp$(PY_EXT_SUFFIX): %-npsp-pywrap-GENERATED.o libmrcal.so libmrcal.so.${ABI_VERSION}
+mrcal/_%_npsp$(PY_EXT_SUFFIX): %-npsp-pywrap-GENERATED.o libmrcal.$(SO) libmrcal.$(SO).${ABI_VERSION}
 	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $< -lmrcal -o $@
 
 ALL_NPSP_C  := $(patsubst %,%-npsp-pywrap-GENERATED.c,$(ALL_NPSP_EXTENSION_MODULES))
@@ -125,10 +132,10 @@
 $(ALL_NPSP_O): CFLAGS += -Wno-array-bounds
 
 mrcal-pywrap.o: $(addsuffix .h,$(wildcard *.docstring))
-mrcal/_mrcal$(PY_EXT_SUFFIX): mrcal-pywrap.o libmrcal.so libmrcal.so.${ABI_VERSION}
-	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $< -lmrcal -o $@
-# Needed on Debian. Unnecessary, but harmless on Arch Linux
-mrcal-pywrap.o: CFLAGS += -I/usr/include/suitesparse
+mrcal/_mrcal$(PY_EXT_SUFFIX): mrcal-pywrap.o libmrcal.$(SO) libmrcal.$(SO).${ABI_VERSION}
+	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $< -lmrcal -lsuitesparseconfig -o $@
+
+CFLAGS += -I/usr/include/suitesparse
 PYTHON_OBJECTS := mrcal-pywrap.o $(ALL_NPSP_O)
 
 # In the python api I have to cast a PyCFunctionWithKeywords to a PyCFunction,
@@ -142,7 +149,7 @@
 DIST_PY3_MODULES := mrcal
 
 all: mrcal/_mrcal$(PY_EXT_SUFFIX) $(ALL_NPSP_SO)
-EXTRA_CLEAN += mrcal/*.so
+EXTRA_CLEAN += mrcal/*.$(SO)
 
 include Makefile.doc
 include Makefile.tests
