=== debian/changelog ===
mrcal (2.4.1-4build2) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 21 Oct 2025 17:45:46 +0000

mrcal (2.4.1-4build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 14:22:32 +0000

mrcal (2.4.1-4) unstable; urgency=medium

  * Team upload.
  * Workaround for NumPy 2

 -- Timo Röhling <roehling@debian.org>  Wed, 29 Jan 2025 22:46:29 +0100

mrcal (2.4.1-3) unstable; urgency=medium

  * Added Build-Depends: python3-setuptools (Closes: #1080677)

 -- Dima Kogan <dkogan@debian.org>  Thu, 05 Sep 2024 19:17:50 -0700

mrcal (2.4.1-2) unstable; urgency=medium

  * Removed unintended symbol export

  * Initialize Python objects more properly to fix build failure in gcc-14
    (Closes: #1075295)

 -- Dima Kogan <dkogan@debian.org>  Sat, 06 Jul 2024 22:16:47 -0700

mrcal (2.4.1-1) unstable; urgency=medium

  * New upstream release
    Bug fixes in mrcal-stereo

 -- Dima Kogan <dkogan@debian.org>  Tue, 13 Feb 2024 22:21:44 -0800

mrcal (2.4-1) unstable; urgency=medium

  * New upstream release
  * ABI bump: libmrcal4

 -- Dima Kogan <dkogan@debian.org>  Mon, 22 Jan 2024 18:15:37 -0800
