=== debian/control ===
--- 
+++ 
@@ -6,6 +6,9 @@
 # with older debian-based distros
  debhelper (>= 11),
  dh-python,
+# for "make install" to work. See
+#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080677
+ python3-setuptools,
  libdogleg-dev (>= 0.16-4),
  libsuitesparse-dev (>= 1:4.5.2),
  libfreeimage-dev,
@@ -20,7 +23,9 @@
 # cross-building doesn't work anyway
  python3-numpy:native,
 # Need this even when not running tests: *-genpywrap.py uses npsp
- python3-numpysane (>= 0.35),
+# Need at least 0.37 for the interactive pixel picking in mrcal-stereo to
+# work
+ python3-numpysane (>= 0.37),
  mrbuild,
 # These are for the tests only
  python3-gnuplotlib (>= 0.38) <!nocheck>,
@@ -34,7 +39,7 @@
 Vcs-Browser: https://salsa.debian.org/science-team/mrcal
 Testsuite: autopkgtest-pkg-python
 
-Package: libmrcal3
+Package: libmrcal4
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -47,7 +52,7 @@
 
 Package: mrcal
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal3 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal4 (= ${binary:Version}),
          python3-mrcal (= ${binary:Version}),
          python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
          python3-scipy (>= 0.18),  python3-ipython,
@@ -65,7 +70,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libmrcal3 (= ${binary:Version})
+Depends: ${misc:Depends}, libmrcal4 (= ${binary:Version})
 Description: Calibration and SFM library
  A photogrammetry toolkit that provides improved methods for making and using
  camera models (calibration, tracking, mapping, etc). The focus is on
@@ -76,13 +81,15 @@
 Section: python
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal3 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal4 (= ${binary:Version}),
          ${python3:Depends},
          python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
          python3-opencv, python3-numpy, python3-scipy (>= 0.18),
          python3-shapely, python3-ipython,
 # for image_transformation_map(), not for plotting
-         python3-matplotlib
+         python3-matplotlib,
+# for reading/writing kalibr model files
+         python3-yaml
 Provides: ${python3:Provides}
 Description: Calibration and SFM library
  A photogrammetry toolkit that provides improved methods for making and using
