## mrcal 2.5

=== Makefile ===
--- 
+++ 
@@ -16,21 +16,69 @@
 
 
 PROJECT_NAME := mrcal
-ABI_VERSION  := 4
+ABI_VERSION  := 5
 TAIL_VERSION := 0
 
-VERSION := $(VERSION_FROM_PROJECT)
+VERSION = $(VERSION_FROM_PROJECT)
 
 LIB_SOURCES +=			\
   mrcal.c			\
-  mrcal-opencv.c		\
-  mrcal-image.c			\
+  opencv.c			\
+  uncertainty.c			\
+  image.c			\
   stereo.c			\
   poseutils.c			\
   poseutils-opencv.c		\
   poseutils-uses-autodiff.cc	\
   triangulation.cc              \
-  cahvore.cc
+  cahvore.cc                    \
+  traverse-sensor-links.c       \
+  heap.cc                       \
+  python-cameramodel-converter.c
+
+
+# This is a utility function for external Python wrapping. I link this into
+# libmrcal.so, but libmrcal.so does NOT link with libpython. 99% of the usage of
+# libmrcal.so will not use this, so it should work without libpython. People
+# using this function will be doing so as part of PyArg_ParseTupleAndKeywords(),
+# so they will be linking to libpython anyway. Thus I weaken all the references
+# to libpython here. c_build_rule is the default logic in mrbuild
+#
+# This is a DEEP rabbithole. With Debian/trixie (released summer 2025) objcopy
+# --weaken works to weaken the symbols after compiling. With older objcopy (not
+# sure which), the objcopy command completes successfully, but it doesn't
+# actually weaken the symbols. I thus run nm to find the non-weakened symbols;
+# if any remain, I recompile, explicitly setting __attribute__((weak)) on these
+# symbols. I can't do this on the first pass because before compiling even once
+# I don't know which Py symbols I'm going to get (some are generated by the
+# Python internals).
+#
+# Finally, the second-pass-recompile-with-attribute-weak doesn't work with
+# clang: the references produced by inline functions in Python.h that *I* am not
+# calling are not weakened. I catch this case here, and throw an error. In the
+# very near future, few people are going to have the too-old binutils, and we'll
+# be done
+python-cameramodel-converter.o: %.o:%.c
+	$(c_build_rule) && mv $@ _$@
+	$(OBJCOPY) --wildcard --weaken-symbol='Py*' --weaken-symbol='_Py*' _$@ $@ && mv $@ _$@
+	$(NM) --undef _$@ | awk '$$1 == "U" && $$2 ~ "Py" { print $$2 }' > python-cameramodel-converter-py-symbol-refs
+	if [ -s python-cameramodel-converter-py-symbol-refs ]; then			\
+	  < python-cameramodel-converter-py-symbol-refs					\
+	    awk 'BEGIN {ORS=""; print "#define PY_REFS(_) " } {print "_("$$1") "} '	\
+	  > python-cameramodel-converter-py-symbol-refs.h				\
+	  &&										\
+	  $(c_build_rule) -DWEAKEN_PY_REFS;						\
+	  if $(NM) --undef $@ | grep -E -q '\sU\s+_?Py'; then				\
+	    echo "ERROR: Strong symbols remain! See the Makefile for notes";		\
+	    false;									\
+	  fi										\
+	else										\
+	  mv _$@ $@;									\
+	fi
+EXTRA_CLEAN += \
+  python-cameramodel-converter-py-symbol-refs   \
+  python-cameramodel-converter-py-symbol-refs.h \
+  _python-cameramodel-converter.o
 
 ifneq (${USE_LIBELAS},) # using libelas
 LIB_SOURCES := $(LIB_SOURCES) stereo-matching-libelas.cc
@@ -38,12 +86,13 @@
 
 
 BIN_SOURCES +=					\
-  test-gradients.c				\
+  test/test-gradients.c				\
   test/test-cahvor.c				\
   test/test-lensmodel-string-manipulation.c     \
-  test/test-parser-cameramodel.c
-
-LDLIBS += -ldogleg -lfreeimage
+  test/test-parser-cameramodel.c                \
+  test/test-heap.c
+
+LDLIBS += -ldogleg -lstb -lpng -ljpeg -llapack
 
 ifneq (${USE_LIBELAS},) # using libelas
 LDLIBS += -lelas
@@ -59,13 +108,15 @@
 
 DIST_INCLUDE +=			\
 	mrcal.h			\
-	mrcal-image.h		\
-	mrcal-internal.h	\
+	image.h			\
+	internal.h		\
 	basic-geometry.h	\
 	poseutils.h		\
 	triangulation.h		\
-	mrcal-types.h		\
-	stereo.h
+	types.h			\
+	stereo.h                \
+	heap.h                  \
+	python-cameramodel-converter.h
 
 
 
@@ -136,12 +187,8 @@
 	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $< -lmrcal -lsuitesparseconfig -o $@
 
 CFLAGS += -I/usr/include/suitesparse
-PYTHON_OBJECTS := mrcal-pywrap.o $(ALL_NPSP_O)
-
-# In the python api I have to cast a PyCFunctionWithKeywords to a PyCFunction,
-# and the compiler complains. But that's how Python does it! So I tell the
-# compiler to chill
-$(PYTHON_OBJECTS): CFLAGS += -Wno-cast-function-type
+PYTHON_OBJECTS := mrcal-pywrap.o python-cameramodel-converter.o $(ALL_NPSP_O)
+
 $(PYTHON_OBJECTS): CFLAGS += $(PY_MRBUILD_CFLAGS)
 
 # The python libraries (compiled ones and ones written in python) all live in
@@ -151,7 +198,18 @@
 all: mrcal/_mrcal$(PY_EXT_SUFFIX) $(ALL_NPSP_SO)
 EXTRA_CLEAN += mrcal/*.$(SO)
 
+
+TESTS_ALL_TARGETS := test-all test-nosampling test-triangulation-uncertainty test-external-data
+$(TESTS_ALL_TARGETS): all
+	./test.sh $@
+.PHONY: $(TESTS_ALL_TARGETS)
+test:
+	@echo "Which test set should we run? I know about '$(TESTS_ALL_TARGETS)'" > /dev/stderr; false
+.PHONY: test
+
 include Makefile.doc
-include Makefile.tests
 
 include $(MRBUILD_MK)/Makefile.common.footer
+
+# to work with mrbuild < 1.14
+OBJCOPY ?= objcopy
