=== debian/changelog ===
mrcal (2.5-3) unstable; urgency=medium

  * Patches to fix oversight bugs
    - Shipping extra tools
    - Working across Python versions

 -- Dima Kogan <dkogan@debian.org>  Wed, 31 Dec 2025 00:17:58 -0800

mrcal (2.5-2) unstable; urgency=medium

  * Patches to fix bugs exposed by buildd test failures
    - Slightly looser numerical thresholds
    - We account for endianness mismatches for data read from files on disk

 -- Dima Kogan <dkogan@debian.org>  Sun, 28 Dec 2025 19:33:56 -0800

mrcal (2.5-1) unstable; urgency=medium

  * New upstream release
    No more dependence on libfreeimage-dev. Replaced with Build-Depends:
    libstb-dev,libjpeg-dev,libpng-dev

 -- Dima Kogan <dkogan@debian.org>  Fri, 26 Dec 2025 21:01:01 -0800
