=== debian/control ===
--- 
+++ 
@@ -6,12 +6,16 @@
 # with older debian-based distros
  debhelper (>= 11),
  dh-python,
+# to get the host ARCH-pkgconf into the PKG_CONFIG variable
+ pkgconf,
 # for "make install" to work. See
 #   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080677
  python3-setuptools,
  libdogleg-dev (>= 0.16-4),
  libsuitesparse-dev (>= 1:4.5.2),
- libfreeimage-dev,
+ libstb-dev,
+ libjpeg-dev,
+ libpng-dev,
  perl:any,
  liblist-moreutils-perl:native,
  vnlog,
@@ -19,6 +23,7 @@
  re2c (>= 2),
  python3-all-dev:any,
  libpython3-all-dev,
+ python3-numpy-dev,
 # Needed for *-genpywrap.py. Need arch:build for tests, but testing while
 # cross-building doesn't work anyway
  python3-numpy:native,
@@ -26,8 +31,10 @@
 # Need at least 0.37 for the interactive pixel picking in mrcal-stereo to
 # work
  python3-numpysane (>= 0.37),
- mrbuild,
+ mrbuild (>= 1.14),
+ binutils-for-host,
 # These are for the tests only
+ zsh                          <!nocheck>,
  python3-gnuplotlib (>= 0.38) <!nocheck>,
  python3-opencv               <!nocheck>,
  python3-scipy (>= 0.18)      <!nocheck>
@@ -39,7 +46,7 @@
 Vcs-Browser: https://salsa.debian.org/science-team/mrcal
 Testsuite: autopkgtest-pkg-python
 
-Package: libmrcal4
+Package: libmrcal5
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -52,7 +59,7 @@
 
 Package: mrcal
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal4 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal5 (= ${binary:Version}),
          python3-mrcal (= ${binary:Version}),
          python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
          python3-scipy (>= 0.18),  python3-ipython,
@@ -70,7 +77,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libmrcal4 (= ${binary:Version})
+Depends: ${misc:Depends}, libmrcal5 (= ${binary:Version})
 Description: Calibration and SFM library
  A photogrammetry toolkit that provides improved methods for making and using
  camera models (calibration, tracking, mapping, etc). The focus is on
@@ -81,7 +88,7 @@
 Section: python
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal4 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal5 (= ${binary:Version}),
          ${python3:Depends},
          python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
          python3-opencv, python3-numpy, python3-scipy (>= 0.18),
