=== debian/watch ===
version=4
opts=\
uversionmangle=s/pre/~/ \
https://github.com/dkogan/mrcal/tags .*/v(\d\S+)\.tar\.gz
