## mrcal 2.5.1

=== Makefile ===
--- 
+++ 
@@ -9,9 +9,13 @@
 # on anything in non-free, so I default to not using libelas
 USE_LIBELAS ?= 0
 
+# If true, we compile libstb into image.o and libmrcal.so. If false, we link to
+# an external libstb.so. We default to building it ourselves on macos and using
+# the library otherwise
+USE_LOCAL_STB_IMPLEMENTATION ?= $(COND_DARWIN)
 
 # convert all USE_XXX:=0 to an empty string
-$(foreach v,$(filter USE_%,$(.VARIABLES)),$(if $(filter 0,${$v}),$(eval undefine $v)))
+$(foreach v,$(filter USE_%,$(.VARIABLES)),$(if $(filter 0,${$v}),$(eval $v :=)))
 # to print them all: $(foreach v,$(filter USE_%,$(.VARIABLES)),$(warning $v = '${$v}'))
 
 
@@ -37,53 +41,13 @@
   python-cameramodel-converter.c
 
 
-# This is a utility function for external Python wrapping. I link this into
-# libmrcal.so, but libmrcal.so does NOT link with libpython. 99% of the usage of
-# libmrcal.so will not use this, so it should work without libpython. People
-# using this function will be doing so as part of PyArg_ParseTupleAndKeywords(),
-# so they will be linking to libpython anyway. Thus I weaken all the references
-# to libpython here. c_build_rule is the default logic in mrbuild
-#
-# This is a DEEP rabbithole. With Debian/trixie (released summer 2025) objcopy
-# --weaken works to weaken the symbols after compiling. With older objcopy (not
-# sure which), the objcopy command completes successfully, but it doesn't
-# actually weaken the symbols. I thus run nm to find the non-weakened symbols;
-# if any remain, I recompile, explicitly setting __attribute__((weak)) on these
-# symbols. I can't do this on the first pass because before compiling even once
-# I don't know which Py symbols I'm going to get (some are generated by the
-# Python internals).
-#
-# Finally, the second-pass-recompile-with-attribute-weak doesn't work with
-# clang: the references produced by inline functions in Python.h that *I* am not
-# calling are not weakened. I catch this case here, and throw an error. In the
-# very near future, few people are going to have the too-old binutils, and we'll
-# be done
-python-cameramodel-converter.o: %.o:%.c
-	$(c_build_rule) && mv $@ _$@
-	$(OBJCOPY) --wildcard --weaken-symbol='Py*' --weaken-symbol='_Py*' _$@ $@ && mv $@ _$@
-	$(NM) --undef _$@ | awk '$$1 == "U" && $$2 ~ "Py" { print $$2 }' > python-cameramodel-converter-py-symbol-refs
-	if [ -s python-cameramodel-converter-py-symbol-refs ]; then			\
-	  < python-cameramodel-converter-py-symbol-refs					\
-	    awk 'BEGIN {ORS=""; print "#define PY_REFS(_) " } {print "_("$$1") "} '	\
-	  > python-cameramodel-converter-py-symbol-refs.h				\
-	  &&										\
-	  $(c_build_rule) -DWEAKEN_PY_REFS;						\
-	  if $(NM) --undef $@ | grep -E -q '\sU\s+_?Py'; then				\
-	    echo "ERROR: Strong symbols remain! See the Makefile for notes";		\
-	    false;									\
-	  fi										\
-	else										\
-	  mv _$@ $@;									\
-	fi
-EXTRA_CLEAN += \
-  python-cameramodel-converter-py-symbol-refs   \
-  python-cameramodel-converter-py-symbol-refs.h \
-  _python-cameramodel-converter.o
-
 ifneq (${USE_LIBELAS},) # using libelas
 LIB_SOURCES := $(LIB_SOURCES) stereo-matching-libelas.cc
 endif
 
+ifneq ($(USE_LOCAL_STB_IMPLEMENTATION),)
+image.o: CFLAGS += -DSTB_IMAGE_IMPLEMENTATION=1
+endif
 
 BIN_SOURCES +=					\
   test/test-gradients.c				\
@@ -92,7 +56,7 @@
   test/test-parser-cameramodel.c                \
   test/test-heap.c
 
-LDLIBS += -ldogleg -lstb -lpng -ljpeg -llapack
+LDLIBS += -ldogleg $(if $(USE_LOCAL_STB_IMPLEMENTATION),,-lstb) -lpng -ljpeg -llapack
 
 ifneq (${USE_LIBELAS},) # using libelas
 LDLIBS += -lelas
@@ -127,6 +91,8 @@
 	mrcal-show-splined-model-correction	\
 	mrcal-show-projection-uncertainty	\
 	mrcal-show-projection-diff		\
+	mrcal-show-model-resolution		\
+	mrcal-show-stereo-pair-diff		\
 	mrcal-reproject-points			\
 	mrcal-reproject-image			\
 	mrcal-graft-models			\
@@ -168,6 +134,67 @@
 	mkdir -p $@
 
 ######### python stuff
+
+# python-cameramodel-converter contains a utility function for external Python
+# wrapping. I link this into libmrcal.so, but libmrcal.so does NOT link with
+# libpython. 99% of the usage of libmrcal.so will not use this, so it should
+# work without libpython. People using this function will be doing so as part of
+# PyArg_ParseTupleAndKeywords(), so they will be linking to libpython anyway.
+# Thus I weaken all the references to libpython here. c_build_rule is the
+# default logic in mrbuild
+#
+# This is a DEEP rabbithole. With Debian/trixie (released summer 2025) objcopy
+# --weaken works to weaken the symbols after compiling. With older objcopy (not
+# sure which), the objcopy command completes successfully, but it doesn't
+# actually weaken the symbols. I thus run nm to find the non-weakened symbols;
+# if any remain, I recompile, explicitly setting __attribute__((weak)) on these
+# symbols. I can't do this on the first pass because before compiling even once
+# I don't know which Py symbols I'm going to get (some are generated by the
+# Python internals).
+#
+# Finally, the second-pass-recompile-with-attribute-weak doesn't work with
+# clang: the references produced by inline functions in Python.h that *I* am not
+# calling are not weakened. I catch this case here, and throw an error. In the
+# very near future, few people are going to have the too-old binutils, and we'll
+# be done
+#
+# The above is all for Linux. On macos weak symbols are more work. The userspace
+# tools aren't available, and I THINK the semantics aren't the same. But I can
+# tell the loader to allow undefined references to exist, if those functions
+# aren't called. I pass that option, and I'm done
+ifneq ($(COND_DARWIN),)
+   $(info libmrcal.$(SO): LDFLAGS += -Wl,-undefined,dynamic_lookup)
+   libmrcal.$(SO): LDFLAGS += -Wl,-undefined,dynamic_lookup
+else
+
+python-cameramodel-converter.o: %.o:%.c
+	$(c_build_rule) && mv $@ _$@
+	$(OBJCOPY) --wildcard --weaken-symbol='Py*' --weaken-symbol='_Py*' _$@ $@ && mv $@ _$@
+	$(NM) -u _$@ | awk '$$1 == "U" && $$2 ~ "Py" { print $$2 }' > python-cameramodel-converter-py-symbol-refs
+	if [ -s python-cameramodel-converter-py-symbol-refs ]; then			\
+	  < python-cameramodel-converter-py-symbol-refs					\
+	    awk 'BEGIN {ORS=""; print "#define PY_REFS(_) " } {print "_("$$1") "} '	\
+	  > python-cameramodel-converter-py-symbol-refs.h				\
+	  &&										\
+	  $(c_build_rule) -DWEAKEN_PY_REFS;						\
+	  if $(NM) -u $@ | grep -E -q '\sU\s+_?Py'; then				\
+	    echo "ERROR: Strong symbols remain! See the Makefile for notes";		\
+	    false;									\
+	  fi										\
+	else										\
+	  mv _$@ $@;									\
+	fi
+EXTRA_CLEAN += \
+  python-cameramodel-converter-py-symbol-refs   \
+  python-cameramodel-converter-py-symbol-refs.h \
+  _python-cameramodel-converter.o
+
+
+endif
+
+
+
+
 %-npsp-pywrap-GENERATED.c: %-genpywrap.py
 	python3 $< > $@.tmp && mv $@.tmp $@
 mrcal/_%_npsp$(PY_EXT_SUFFIX): %-npsp-pywrap-GENERATED.o libmrcal.$(SO) libmrcal.$(SO).${ABI_VERSION}
@@ -186,7 +213,6 @@
 mrcal/_mrcal$(PY_EXT_SUFFIX): mrcal-pywrap.o libmrcal.$(SO) libmrcal.$(SO).${ABI_VERSION}
 	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $< -lmrcal -lsuitesparseconfig -o $@
 
-CFLAGS += -I/usr/include/suitesparse
 PYTHON_OBJECTS := mrcal-pywrap.o python-cameramodel-converter.o $(ALL_NPSP_O)
 
 $(PYTHON_OBJECTS): CFLAGS += $(PY_MRBUILD_CFLAGS)
@@ -196,7 +222,7 @@
 DIST_PY3_MODULES := mrcal
 
 all: mrcal/_mrcal$(PY_EXT_SUFFIX) $(ALL_NPSP_SO)
-EXTRA_CLEAN += mrcal/*.$(SO)
+EXTRA_CLEAN += mrcal/*$(PY_EXT_SUFFIX)
 
 
 TESTS_ALL_TARGETS := test-all test-nosampling test-triangulation-uncertainty test-external-data
