=== debian/changelog ===
mrcal (2.5.1-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Fri, 09 Jan 2026 17:21:44 -0800
