=== debian/control ===
--- 
+++ 
@@ -18,8 +18,6 @@
  libpng-dev,
  perl:any,
  liblist-moreutils-perl:native,
- vnlog,
- chrpath,
  re2c (>= 2),
  python3-all-dev:any,
  libpython3-all-dev,
@@ -34,6 +32,7 @@
  mrbuild (>= 1.14),
  binutils-for-host,
 # These are for the tests only
+ vnlog                        <!nocheck>,
  zsh                          <!nocheck>,
  python3-gnuplotlib (>= 0.38) <!nocheck>,
  python3-opencv               <!nocheck>,
